--- old/usr/src/cmd/mdb/common/mdb/mdb_demangle.c	Tue Feb 27 22:54:10 2018
+++ new/usr/src/cmd/mdb/common/mdb/mdb_demangle.c	Tue Feb 27 22:54:10 2018
@@ -23,7 +23,7 @@
  * Copyright 2001-2002 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  *
- * Copyright 2017 Jason King
+ * Copyright 2018 Jason King
  */
 
 #include <mdb/mdb_modapi.h>
@@ -31,12 +31,10 @@
 #include <mdb/mdb_err.h>
 #include <mdb/mdb.h>
 
-#include <demangle.h>
 #include <strings.h>
 #include <unistd.h>
 #include <dlfcn.h>
 #include <link.h>
-#include <sysdemangle.h>
 
 static void *
 mdb_dem_alloc(size_t len)
@@ -208,8 +206,11 @@
 	}
 
 	res = sysdemangle(name + prefixlen, dmp->dm_lang, &mdb_dem_demops);
-	if (res == NULL && errno != EINVAL)
-		mdb_warn("Error while demangling");
+	if (res == NULL) {
+		if (errno != EINVAL)
+			mdb_warn("Error while demangling");
+		return (-1);
+	}
 
 	reslen = (res != NULL) ? strlen(res) : 0;
 	reslen += prefixlen;
@@ -229,8 +230,11 @@
 
 	if (prefixlen > 0)
 		(void) strlcpy(dmp->dm_buf, name, prefixlen);
-	if (res != NULL)
+
+	if (res != NULL) {
 		(void) strlcat(dmp->dm_buf, res, dmp->dm_len);
+		mdb_dem_free(res, strlen(res) + 1);
+	}
 
 	/*
 	 * Save the position of the demangled string for mdb_dem_filter()
